import { typeof as _typeof, slicedToArray as _slicedToArray } from '../../../_virtual/_rollupPluginBabelHelpers.js';

/**
 * Функция глубокого копирования дерева элементов.
 * Копируются лишь объекты из массива children.
 */
var deepCopy = function deepCopy(obj) {
  if (obj === null || _typeof(obj) !== 'object') {
    return obj;
  }
  if (Array.isArray(obj)) {
    return obj.map(function (item) {
      return deepCopy(item);
    });
  }
  return Object.fromEntries(Object.entries(obj).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
      key = _ref2[0],
      value = _ref2[1];
    return key === 'children' ? [key, deepCopy(value)] : [key, value];
  }));
};

export { deepCopy };
